#!/usr/bin/env node

// Generated by Haxe 3.4.0
if (typeof process !== "undefined") if (process.version < "v4.0.0") console.warn("Module " + (typeof(module) == "undefined" ? "" : module.filename) + " requires node.js version 4.0.0 or higher");

(function ($global) { "use strict";
var $estr = function() { return js_Boot.__string_rec(this,''); };
function $extend(from, fields) {
	function Inherit() {} Inherit.prototype = from; var proto = new Inherit();
	for (var name in fields) proto[name] = fields[name];
	if( fields.toString !== Object.prototype.toString ) proto.toString = fields.toString;
	return proto;
}
var DateTools = function() { };
DateTools.__name__ = true;
DateTools.__format_get = function(d,e) {
	switch(e) {
	case "%":
		return "%";
	case "A":
		return DateTools.DAY_NAMES[d.getDay()];
	case "B":
		return DateTools.MONTH_NAMES[d.getMonth()];
	case "C":
		return StringTools.lpad(Std.string(d.getFullYear() / 100 | 0),"0",2);
	case "D":
		return DateTools.__format(d,"%m/%d/%y");
	case "F":
		return DateTools.__format(d,"%Y-%m-%d");
	case "I":case "l":
		var hour = d.getHours() % 12;
		return StringTools.lpad(Std.string(hour == 0 ? 12 : hour),e == "I" ? "0" : " ",2);
	case "M":
		return StringTools.lpad(Std.string(d.getMinutes()),"0",2);
	case "R":
		return DateTools.__format(d,"%H:%M");
	case "S":
		return StringTools.lpad(Std.string(d.getSeconds()),"0",2);
	case "T":
		return DateTools.__format(d,"%H:%M:%S");
	case "Y":
		return Std.string(d.getFullYear());
	case "a":
		return DateTools.DAY_SHORT_NAMES[d.getDay()];
	case "b":case "h":
		return DateTools.MONTH_SHORT_NAMES[d.getMonth()];
	case "d":
		return StringTools.lpad(Std.string(d.getDate()),"0",2);
	case "e":
		return Std.string(d.getDate());
	case "H":case "k":
		return StringTools.lpad(Std.string(d.getHours()),e == "H" ? "0" : " ",2);
	case "m":
		return StringTools.lpad(Std.string(d.getMonth() + 1),"0",2);
	case "n":
		return "\n";
	case "p":
		if(d.getHours() > 11) {
			return "PM";
		} else {
			return "AM";
		}
		break;
	case "r":
		return DateTools.__format(d,"%I:%M:%S %p");
	case "s":
		return Std.string(d.getTime() / 1000 | 0);
	case "t":
		return "\t";
	case "u":
		var t = d.getDay();
		if(t == 0) {
			return "7";
		} else if(t == null) {
			return "null";
		} else {
			return "" + t;
		}
		break;
	case "w":
		return Std.string(d.getDay());
	case "y":
		return StringTools.lpad(Std.string(d.getFullYear() % 100),"0",2);
	default:
		throw new js__$Boot_HaxeError("Date.format %" + e + "- not implemented yet.");
	}
};
DateTools.__format = function(d,f) {
	var r_b = "";
	var p = 0;
	while(true) {
		var np = f.indexOf("%",p);
		if(np < 0) {
			break;
		}
		var len = np - p;
		r_b += len == null ? HxOverrides.substr(f,p,null) : HxOverrides.substr(f,p,len);
		r_b += Std.string(DateTools.__format_get(d,HxOverrides.substr(f,np + 1,1)));
		p = np + 2;
	}
	var len1 = f.length - p;
	r_b += len1 == null ? HxOverrides.substr(f,p,null) : HxOverrides.substr(f,p,len1);
	return r_b;
};
DateTools.format = function(d,f) {
	return DateTools.__format(d,f);
};
var HxOverrides = function() { };
HxOverrides.__name__ = true;
HxOverrides.dateStr = function(date) {
	var m = date.getMonth() + 1;
	var d = date.getDate();
	var h = date.getHours();
	var mi = date.getMinutes();
	var s = date.getSeconds();
	return date.getFullYear() + "-" + (m < 10 ? "0" + m : "" + m) + "-" + (d < 10 ? "0" + d : "" + d) + " " + (h < 10 ? "0" + h : "" + h) + ":" + (mi < 10 ? "0" + mi : "" + mi) + ":" + (s < 10 ? "0" + s : "" + s);
};
HxOverrides.strDate = function(s) {
	var _g = s.length;
	switch(_g) {
	case 8:
		var k = s.split(":");
		var d = new Date();
		d["setTime"](0);
		d["setUTCHours"](k[0]);
		d["setUTCMinutes"](k[1]);
		d["setUTCSeconds"](k[2]);
		return d;
	case 10:
		var k1 = s.split("-");
		return new Date(k1[0],k1[1] - 1,k1[2],0,0,0);
	case 19:
		var k2 = s.split(" ");
		var y = k2[0].split("-");
		var t = k2[1].split(":");
		return new Date(y[0],y[1] - 1,y[2],t[0],t[1],t[2]);
	default:
		throw new js__$Boot_HaxeError("Invalid date format : " + s);
	}
};
HxOverrides.cca = function(s,index) {
	var x = s.charCodeAt(index);
	if(x != x) {
		return undefined;
	}
	return x;
};
HxOverrides.substr = function(s,pos,len) {
	if(len == null) {
		len = s.length;
	} else if(len < 0) {
		if(pos == 0) {
			len = s.length + len;
		} else {
			return "";
		}
	}
	return s.substr(pos,len);
};
HxOverrides.remove = function(a,obj) {
	var i = a.indexOf(obj);
	if(i == -1) {
		return false;
	}
	a.splice(i,1);
	return true;
};
HxOverrides.iter = function(a) {
	return { cur : 0, arr : a, hasNext : function() {
		return this.cur < this.arr.length;
	}, next : function() {
		return this.arr[this.cur++];
	}};
};
var Lambda = function() { };
Lambda.__name__ = true;
Lambda.has = function(it,elt) {
	var x = $iterator(it)();
	while(x.hasNext()) if(x.next() == elt) {
		return true;
	}
	return false;
};
Math.__name__ = true;
var Reflect = function() { };
Reflect.__name__ = true;
Reflect.field = function(o,field) {
	try {
		return o[field];
	} catch( e ) {
		return null;
	}
};
Reflect.fields = function(o) {
	var a = [];
	if(o != null) {
		var hasOwnProperty = Object.prototype.hasOwnProperty;
		for( var f in o ) {
		if(f != "__id__" && f != "hx__closures__" && hasOwnProperty.call(o,f)) {
			a.push(f);
		}
		}
	}
	return a;
};
Reflect.compare = function(a,b) {
	if(a == b) {
		return 0;
	} else if(a > b) {
		return 1;
	} else {
		return -1;
	}
};
var Std = function() { };
Std.__name__ = true;
Std.string = function(s) {
	return js_Boot.__string_rec(s,"");
};
Std.parseInt = function(x) {
	var v = parseInt(x,10);
	if(v == 0 && (HxOverrides.cca(x,1) == 120 || HxOverrides.cca(x,1) == 88)) {
		v = parseInt(x);
	}
	if(isNaN(v)) {
		return null;
	}
	return v;
};
var StringTools = function() { };
StringTools.__name__ = true;
StringTools.startsWith = function(s,start) {
	if(s.length >= start.length) {
		return HxOverrides.substr(s,0,start.length) == start;
	} else {
		return false;
	}
};
StringTools.endsWith = function(s,end) {
	var elen = end.length;
	var slen = s.length;
	if(slen >= elen) {
		return HxOverrides.substr(s,slen - elen,elen) == end;
	} else {
		return false;
	}
};
StringTools.isSpace = function(s,pos) {
	var c = HxOverrides.cca(s,pos);
	if(!(c > 8 && c < 14)) {
		return c == 32;
	} else {
		return true;
	}
};
StringTools.ltrim = function(s) {
	var l = s.length;
	var r = 0;
	while(r < l && StringTools.isSpace(s,r)) ++r;
	if(r > 0) {
		return HxOverrides.substr(s,r,l - r);
	} else {
		return s;
	}
};
StringTools.rtrim = function(s) {
	var l = s.length;
	var r = 0;
	while(r < l && StringTools.isSpace(s,l - r - 1)) ++r;
	if(r > 0) {
		return HxOverrides.substr(s,0,l - r);
	} else {
		return s;
	}
};
StringTools.trim = function(s) {
	return StringTools.ltrim(StringTools.rtrim(s));
};
StringTools.lpad = function(s,c,l) {
	if(c.length <= 0) {
		return s;
	}
	while(s.length < l) s = c + s;
	return s;
};
StringTools.replace = function(s,sub,by) {
	return s.split(sub).join(by);
};
var Sys = function() { };
Sys.__name__ = true;
Sys.systemName = function() {
	var _g = process.platform;
	switch(_g) {
	case "darwin":
		return "Mac";
	case "freebsd":
		return "BSD";
	case "linux":
		return "Linux";
	case "win32":
		return "Windows";
	default:
		return _g;
	}
};
var haxe_io_Output = function() { };
haxe_io_Output.__name__ = true;
haxe_io_Output.prototype = {
	writeByte: function(c) {
		throw new js__$Boot_HaxeError("Not implemented");
	}
	,writeBytes: function(s,pos,len) {
		if(pos < 0 || len < 0 || pos + len > s.length) {
			throw new js__$Boot_HaxeError(haxe_io_Error.OutsideBounds);
		}
		var b = s.b;
		var k = len;
		while(k > 0) {
			this.writeByte(b[pos]);
			++pos;
			--k;
		}
		return len;
	}
	,writeFullBytes: function(s,pos,len) {
		while(len > 0) {
			var k = this.writeBytes(s,pos,len);
			pos += k;
			len -= k;
		}
	}
	,writeString: function(s) {
		var b = haxe_io_Bytes.ofString(s);
		this.writeFullBytes(b,0,b.length);
	}
	,__class__: haxe_io_Output
};
var _$Sys_FileOutput = function(fd) {
	this.fd = fd;
};
_$Sys_FileOutput.__name__ = true;
_$Sys_FileOutput.__super__ = haxe_io_Output;
_$Sys_FileOutput.prototype = $extend(haxe_io_Output.prototype,{
	writeByte: function(c) {
		js_node_Fs.writeSync(this.fd,String.fromCharCode(c));
	}
	,writeBytes: function(s,pos,len) {
		return js_node_Fs.writeSync(this.fd,new js_node_buffer_Buffer(s.b.bufferValue),pos,len);
	}
	,writeString: function(s) {
		js_node_Fs.writeSync(this.fd,s);
	}
	,__class__: _$Sys_FileOutput
});
var haxe_StackItem = { __ename__ : true, __constructs__ : ["CFunction","Module","FilePos","Method","LocalFunction"] };
haxe_StackItem.CFunction = ["CFunction",0];
haxe_StackItem.CFunction.toString = $estr;
haxe_StackItem.CFunction.__enum__ = haxe_StackItem;
haxe_StackItem.Module = function(m) { var $x = ["Module",1,m]; $x.__enum__ = haxe_StackItem; $x.toString = $estr; return $x; };
haxe_StackItem.FilePos = function(s,file,line) { var $x = ["FilePos",2,s,file,line]; $x.__enum__ = haxe_StackItem; $x.toString = $estr; return $x; };
haxe_StackItem.Method = function(classname,method) { var $x = ["Method",3,classname,method]; $x.__enum__ = haxe_StackItem; $x.toString = $estr; return $x; };
haxe_StackItem.LocalFunction = function(v) { var $x = ["LocalFunction",4,v]; $x.__enum__ = haxe_StackItem; $x.toString = $estr; return $x; };
var haxe_IMap = function() { };
haxe_IMap.__name__ = true;
var haxe_Timer = function(time_ms) {
	var me = this;
	this.id = setInterval(function() {
		me.run();
	},time_ms);
};
haxe_Timer.__name__ = true;
haxe_Timer.delay = function(f,time_ms) {
	var t = new haxe_Timer(time_ms);
	t.run = function() {
		t.stop();
		f();
	};
	return t;
};
haxe_Timer.prototype = {
	stop: function() {
		if(this.id == null) {
			return;
		}
		clearInterval(this.id);
		this.id = null;
	}
	,run: function() {
	}
	,__class__: haxe_Timer
};
var haxe_ds_IntMap = function() {
	this.h = { };
};
haxe_ds_IntMap.__name__ = true;
haxe_ds_IntMap.__interfaces__ = [haxe_IMap];
haxe_ds_IntMap.prototype = {
	__class__: haxe_ds_IntMap
};
var haxe_ds_Option = { __ename__ : true, __constructs__ : ["Some","None"] };
haxe_ds_Option.Some = function(v) { var $x = ["Some",0,v]; $x.__enum__ = haxe_ds_Option; $x.toString = $estr; return $x; };
haxe_ds_Option.None = ["None",1];
haxe_ds_Option.None.toString = $estr;
haxe_ds_Option.None.__enum__ = haxe_ds_Option;
var haxe_ds_StringMap = function() {
	this.h = { };
};
haxe_ds_StringMap.__name__ = true;
haxe_ds_StringMap.__interfaces__ = [haxe_IMap];
haxe_ds_StringMap.prototype = {
	setReserved: function(key,value) {
		if(this.rh == null) {
			this.rh = { };
		}
		this.rh["$" + key] = value;
	}
	,getReserved: function(key) {
		if(this.rh == null) {
			return null;
		} else {
			return this.rh["$" + key];
		}
	}
	,existsReserved: function(key) {
		if(this.rh == null) {
			return false;
		}
		return this.rh.hasOwnProperty("$" + key);
	}
	,__class__: haxe_ds_StringMap
};
var haxe_io_Bytes = function(data) {
	this.length = data.byteLength;
	this.b = new Uint8Array(data);
	this.b.bufferValue = data;
	data.hxBytes = this;
	data.bytes = this.b;
};
haxe_io_Bytes.__name__ = true;
haxe_io_Bytes.ofString = function(s) {
	var a = [];
	var i = 0;
	while(i < s.length) {
		var c = s.charCodeAt(i++);
		if(55296 <= c && c <= 56319) {
			c = c - 55232 << 10 | s.charCodeAt(i++) & 1023;
		}
		if(c <= 127) {
			a.push(c);
		} else if(c <= 2047) {
			a.push(192 | c >> 6);
			a.push(128 | c & 63);
		} else if(c <= 65535) {
			a.push(224 | c >> 12);
			a.push(128 | c >> 6 & 63);
			a.push(128 | c & 63);
		} else {
			a.push(240 | c >> 18);
			a.push(128 | c >> 12 & 63);
			a.push(128 | c >> 6 & 63);
			a.push(128 | c & 63);
		}
	}
	return new haxe_io_Bytes(new Uint8Array(a).buffer);
};
haxe_io_Bytes.ofData = function(b) {
	var hb = b.hxBytes;
	if(hb != null) {
		return hb;
	}
	return new haxe_io_Bytes(b);
};
haxe_io_Bytes.prototype = {
	getString: function(pos,len) {
		if(pos < 0 || len < 0 || pos + len > this.length) {
			throw new js__$Boot_HaxeError(haxe_io_Error.OutsideBounds);
		}
		var s = "";
		var b = this.b;
		var fcc = String.fromCharCode;
		var i = pos;
		var max = pos + len;
		while(i < max) {
			var c = b[i++];
			if(c < 128) {
				if(c == 0) {
					break;
				}
				s += fcc(c);
			} else if(c < 224) {
				s += fcc((c & 63) << 6 | b[i++] & 127);
			} else if(c < 240) {
				s += fcc((c & 31) << 12 | (b[i++] & 127) << 6 | b[i++] & 127);
			} else {
				var u = (c & 15) << 18 | (b[i++] & 127) << 12 | (b[i++] & 127) << 6 | b[i++] & 127;
				s += fcc((u >> 10) + 55232);
				s += fcc(u & 1023 | 56320);
			}
		}
		return s;
	}
	,toString: function() {
		return this.getString(0,this.length);
	}
	,__class__: haxe_io_Bytes
};
var haxe_io_Eof = function() { };
haxe_io_Eof.__name__ = true;
haxe_io_Eof.prototype = {
	toString: function() {
		return "Eof";
	}
	,__class__: haxe_io_Eof
};
var haxe_io_Error = { __ename__ : true, __constructs__ : ["Blocked","Overflow","OutsideBounds","Custom"] };
haxe_io_Error.Blocked = ["Blocked",0];
haxe_io_Error.Blocked.toString = $estr;
haxe_io_Error.Blocked.__enum__ = haxe_io_Error;
haxe_io_Error.Overflow = ["Overflow",1];
haxe_io_Error.Overflow.toString = $estr;
haxe_io_Error.Overflow.__enum__ = haxe_io_Error;
haxe_io_Error.OutsideBounds = ["OutsideBounds",2];
haxe_io_Error.OutsideBounds.toString = $estr;
haxe_io_Error.OutsideBounds.__enum__ = haxe_io_Error;
haxe_io_Error.Custom = function(e) { var $x = ["Custom",3,e]; $x.__enum__ = haxe_io_Error; $x.toString = $estr; return $x; };
var haxe_io_Path = function(path) {
	switch(path) {
	case ".":case "..":
		this.dir = path;
		this.file = "";
		return;
	}
	var c1 = path.lastIndexOf("/");
	var c2 = path.lastIndexOf("\\");
	if(c1 < c2) {
		this.dir = HxOverrides.substr(path,0,c2);
		path = HxOverrides.substr(path,c2 + 1,null);
		this.backslash = true;
	} else if(c2 < c1) {
		this.dir = HxOverrides.substr(path,0,c1);
		path = HxOverrides.substr(path,c1 + 1,null);
	} else {
		this.dir = null;
	}
	var cp = path.lastIndexOf(".");
	if(cp != -1) {
		this.ext = HxOverrides.substr(path,cp + 1,null);
		this.file = HxOverrides.substr(path,0,cp);
	} else {
		this.ext = null;
		this.file = path;
	}
};
haxe_io_Path.__name__ = true;
haxe_io_Path.directory = function(path) {
	var s = new haxe_io_Path(path);
	if(s.dir == null) {
		return "";
	}
	return s.dir;
};
haxe_io_Path.extension = function(path) {
	var s = new haxe_io_Path(path);
	if(s.ext == null) {
		return "";
	}
	return s.ext;
};
haxe_io_Path.addTrailingSlash = function(path) {
	if(path.length == 0) {
		return "/";
	}
	var c1 = path.lastIndexOf("/");
	var c2 = path.lastIndexOf("\\");
	if(c1 < c2) {
		if(c2 != path.length - 1) {
			return path + "\\";
		} else {
			return path;
		}
	} else if(c1 != path.length - 1) {
		return path + "/";
	} else {
		return path;
	}
};
haxe_io_Path.removeTrailingSlashes = function(path) {
	try {
		while(true) {
			var _g = HxOverrides.cca(path,path.length - 1);
			if(_g == null) {
				throw "__break__";
			} else {
				switch(_g) {
				case 47:case 92:
					path = HxOverrides.substr(path,0,-1);
					break;
				default:
					throw "__break__";
				}
			}
		}
	} catch( e ) { if( e != "__break__" ) throw e; }
	return path;
};
haxe_io_Path.prototype = {
	__class__: haxe_io_Path
};
var haxeshim_Scope = function(haxeshimRoot,isGlobal,scopeDir,cwd) {
	this.haxeshimRoot = haxeshimRoot;
	this.isGlobal = isGlobal;
	this.scopeDir = scopeDir;
	this.cwd = cwd;
	this.configFile = "" + scopeDir + "/" + haxeshim_Scope.CONFIG_FILE;
	var src;
	try {
		src = js_node_Fs.readFileSync(this.configFile,{ encoding : "utf8"});
	} catch( e ) {
		if (e instanceof js__$Boot_HaxeError) e = e.val;
		if(isGlobal) {
			throw new js__$Boot_HaxeError("Global config file " + this.configFile + " does not exist or cannot be opened");
		} else {
			throw new js__$Boot_HaxeError("Unable to open file " + this.configFile + " because " + Std.string(e));
		}
	}
	var tmp;
	try {
		tmp = JSON.parse(src);
	} catch( e1 ) {
		if (e1 instanceof js__$Boot_HaxeError) e1 = e1.val;
		new _$Sys_FileOutput(2).writeString("Invalid JSON in file " + this.configFile + ":\n\n" + src + "\n\n");
		throw js__$Boot_HaxeError.wrap(e1);
	}
	this.config = tmp;
	if(this.config.version == null) {
		throw new js__$Boot_HaxeError("No version set in " + this.configFile);
	}
	var _g = this.config.resolveLibs;
	if(_g != null) {
		switch(_g) {
		case "haxelib":case "mixed":
			break;
		default:
			throw new js__$Boot_HaxeError("invalid value " + _g + " for `resolveLibs` in " + this.configFile);
		}
	}
	this.haxeInstallation = this.getInstallation(this.config.version);
	var tmp1 = this.config.resolveLibs;
	var _g1 = new haxe_ds_StringMap();
	var value = "" + haxeshimRoot + "/libs";
	if(__map_reserved["HAXESHIM_LIBCACHE"] != null) {
		_g1.setReserved("HAXESHIM_LIBCACHE",value);
	} else {
		_g1.h["HAXESHIM_LIBCACHE"] = value;
	}
	this.resolver = new haxeshim_Resolver(cwd,scopeDir,tmp1,_g1);
};
haxeshim_Scope.__name__ = true;
haxeshim_Scope.create = function(at,config) {
	js_node_Fs.writeFileSync("" + at + "/" + haxeshim_Scope.CONFIG_FILE,JSON.stringify(config));
};
haxeshim_Scope.exists = function(at) {
	return sys_FileSystem.exists("" + at + "/" + haxeshim_Scope.CONFIG_FILE);
};
haxeshim_Scope.seek = function(options) {
	if(options == null) {
		options = { };
	}
	var cwd;
	var _g = options.cwd;
	if(_g == null) {
		cwd = process.cwd();
	} else {
		cwd = _g;
	}
	var startLookingIn;
	var _g1 = options.startLookingIn;
	if(_g1 == null) {
		startLookingIn = cwd;
	} else {
		startLookingIn = _g1;
	}
	var haxeshimRoot;
	var _g2 = options.haxeshimRoot;
	if(_g2 == null) {
		haxeshimRoot = haxeshim_Scope.DEFAULT_ROOT;
	} else {
		haxeshimRoot = _g2;
	}
	var f = function(haxeshimRoot1,isGlobal,scopeDir,cwd1) {
		return new haxeshim_Scope(haxeshimRoot1,isGlobal,scopeDir,cwd1);
	};
	var a1 = haxeshimRoot;
	var a4 = cwd;
	var make = function(a2,a3) {
		return f(a1,a2,a3,a4);
	};
	var $global = function() {
		return make(true,haxeshimRoot);
	};
	var dig = null;
	dig = function(cur) {
		var _hx_tmp;
		var _hx_tmp1;
		_hx_tmp = sys_FileSystem.exists("" + cur + "/" + haxeshim_Scope.CONFIG_FILE);
		if(_hx_tmp == true) {
			return make(false,cur);
		} else {
			switch(cur) {
			case "":case "/":
				return $global();
			default:
				_hx_tmp1 = cur.split(":");
				if(_hx_tmp1.length == 2) {
					if(_hx_tmp1[1] == "") {
						if(haxeshim_Scope.IS_WINDOWS && _hx_tmp1[0].length == 1) {
							return $global();
						} else {
							var dig1 = haxe_io_Path.removeTrailingSlashes(haxe_io_Path.directory(cur));
							return dig(dig1);
						}
					} else {
						var dig2 = haxe_io_Path.removeTrailingSlashes(haxe_io_Path.directory(cur));
						return dig(dig2);
					}
				} else {
					var dig3 = haxe_io_Path.removeTrailingSlashes(haxe_io_Path.directory(cur));
					return dig(dig3);
				}
			}
		}
	};
	var tmp = haxe_io_Path.removeTrailingSlashes(js_node_Path.resolve(startLookingIn));
	return dig(tmp);
};
haxeshim_Scope.prototype = {
	'delete': function() {
		js_node_Fs.unlinkSync(this.configFile);
	}
	,reconfigure: function(changed) {
		var _g = 0;
		var _g1 = Reflect.fields(changed);
		while(_g < _g1.length) {
			var f = _g1[_g];
			++_g;
			this.config[f] = Reflect.field(changed,f);
		}
		js_node_Fs.writeFileSync(this.configFile,JSON.stringify(this.config));
	}
	,getInstallation: function(version) {
		return new haxeshim_HaxeInstallation("" + this.haxeshimRoot + "/versions/" + version,version,"" + this.haxeshimRoot + "/libs");
	}
	,__class__: haxeshim_Scope
};
var haxeshim_HaxeInstallation = function(path,version,libs) {
	this.path = path;
	this.version = version;
	this.compiler = "" + path + "/haxe" + haxeshim_HaxeInstallation.EXT;
	this.haxelib = "" + path + "/haxelib" + haxeshim_HaxeInstallation.EXT;
	this.stdLib = "" + path + "/std";
	this.libs = libs;
};
haxeshim_HaxeInstallation.__name__ = true;
haxeshim_HaxeInstallation.prototype = {
	__class__: haxeshim_HaxeInstallation
};
var haxeshim_Resolver = function(cwd,scopeDir,mode,defaults) {
	this.cwd = cwd;
	this.scopeDir = scopeDir;
	this.mode = mode;
	this.defaults = defaults;
};
haxeshim_Resolver.__name__ = true;
haxeshim_Resolver.prototype = {
	__class__: haxeshim_Resolver
};
var js__$Boot_HaxeError = function(val) {
	Error.call(this);
	this.val = val;
	this.message = String(val);
	if(Error.captureStackTrace) {
		Error.captureStackTrace(this,js__$Boot_HaxeError);
	}
};
js__$Boot_HaxeError.__name__ = true;
js__$Boot_HaxeError.wrap = function(val) {
	if((val instanceof Error)) {
		return val;
	} else {
		return new js__$Boot_HaxeError(val);
	}
};
js__$Boot_HaxeError.__super__ = Error;
js__$Boot_HaxeError.prototype = $extend(Error.prototype,{
	__class__: js__$Boot_HaxeError
});
var js_Boot = function() { };
js_Boot.__name__ = true;
js_Boot.getClass = function(o) {
	if((o instanceof Array) && o.__enum__ == null) {
		return Array;
	} else {
		var cl = o.__class__;
		if(cl != null) {
			return cl;
		}
		var name = js_Boot.__nativeClassName(o);
		if(name != null) {
			return js_Boot.__resolveNativeClass(name);
		}
		return null;
	}
};
js_Boot.__string_rec = function(o,s) {
	if(o == null) {
		return "null";
	}
	if(s.length >= 5) {
		return "<...>";
	}
	var t = typeof(o);
	if(t == "function" && (o.__name__ || o.__ename__)) {
		t = "object";
	}
	switch(t) {
	case "function":
		return "<function>";
	case "object":
		if(o instanceof Array) {
			if(o.__enum__) {
				if(o.length == 2) {
					return o[0];
				}
				var str = o[0] + "(";
				s += "\t";
				var _g1 = 2;
				var _g = o.length;
				while(_g1 < _g) {
					var i = _g1++;
					if(i != 2) {
						str += "," + js_Boot.__string_rec(o[i],s);
					} else {
						str += js_Boot.__string_rec(o[i],s);
					}
				}
				return str + ")";
			}
			var l = o.length;
			var i1;
			var str1 = "[";
			s += "\t";
			var _g11 = 0;
			var _g2 = l;
			while(_g11 < _g2) {
				var i2 = _g11++;
				str1 += (i2 > 0 ? "," : "") + js_Boot.__string_rec(o[i2],s);
			}
			str1 += "]";
			return str1;
		}
		var tostr;
		try {
			tostr = o.toString;
		} catch( e ) {
			return "???";
		}
		if(tostr != null && tostr != Object.toString && typeof(tostr) == "function") {
			var s2 = o.toString();
			if(s2 != "[object Object]") {
				return s2;
			}
		}
		var k = null;
		var str2 = "{\n";
		s += "\t";
		var hasp = o.hasOwnProperty != null;
		for( var k in o ) {
		if(hasp && !o.hasOwnProperty(k)) {
			continue;
		}
		if(k == "prototype" || k == "__class__" || k == "__super__" || k == "__interfaces__" || k == "__properties__") {
			continue;
		}
		if(str2.length != 2) {
			str2 += ", \n";
		}
		str2 += s + k + " : " + js_Boot.__string_rec(o[k],s);
		}
		s = s.substring(1);
		str2 += "\n" + s + "}";
		return str2;
	case "string":
		return o;
	default:
		return String(o);
	}
};
js_Boot.__interfLoop = function(cc,cl) {
	if(cc == null) {
		return false;
	}
	if(cc == cl) {
		return true;
	}
	var intf = cc.__interfaces__;
	if(intf != null) {
		var _g1 = 0;
		var _g = intf.length;
		while(_g1 < _g) {
			var i = intf[_g1++];
			if(i == cl || js_Boot.__interfLoop(i,cl)) {
				return true;
			}
		}
	}
	return js_Boot.__interfLoop(cc.__super__,cl);
};
js_Boot.__instanceof = function(o,cl) {
	if(cl == null) {
		return false;
	}
	switch(cl) {
	case Array:
		if((o instanceof Array)) {
			return o.__enum__ == null;
		} else {
			return false;
		}
		break;
	case Bool:
		return typeof(o) == "boolean";
	case Dynamic:
		return true;
	case Float:
		return typeof(o) == "number";
	case Int:
		if(typeof(o) == "number") {
			return (o|0) === o;
		} else {
			return false;
		}
		break;
	case String:
		return typeof(o) == "string";
	default:
		if(o != null) {
			if(typeof(cl) == "function") {
				if(o instanceof cl) {
					return true;
				}
				if(js_Boot.__interfLoop(js_Boot.getClass(o),cl)) {
					return true;
				}
			} else if(typeof(cl) == "object" && js_Boot.__isNativeObj(cl)) {
				if(o instanceof cl) {
					return true;
				}
			}
		} else {
			return false;
		}
		if(cl == Class ? o.__name__ != null : false) {
			return true;
		}
		if(cl == Enum ? o.__ename__ != null : false) {
			return true;
		}
		return o.__enum__ == cl;
	}
};
js_Boot.__nativeClassName = function(o) {
	var name = js_Boot.__toStr.call(o).slice(8,-1);
	if(name == "Object" || name == "Function" || name == "Math" || name == "JSON") {
		return null;
	}
	return name;
};
js_Boot.__isNativeObj = function(o) {
	return js_Boot.__nativeClassName(o) != null;
};
js_Boot.__resolveNativeClass = function(name) {
	return $global[name];
};
var js_node_Fs = require("fs");
var js_node_Http = require("http");
var js_node_Https = require("https");
var js_node_Path = require("path");
var js_node_Url = require("url");
var js_node_Zlib = require("zlib");
var js_node_buffer_Buffer = require("buffer").Buffer;
var switchx_Cli = function() { };
switchx_Cli.__name__ = true;
switchx_Cli.main = function() {
	if(!haxeshim_Scope.exists(haxeshim_Scope.DEFAULT_ROOT)) {
		switchx_Fs.ensureDir(haxeshim_Scope.DEFAULT_ROOT + "/");
		haxeshim_Scope.create(haxeshim_Scope.DEFAULT_ROOT,{ version : "stable", resolveLibs : "mixed"});
		switchx_Cli.dispatch(["install","--global"],function() {
			switchx_Cli.dispatch(process.argv.slice(2));
		});
		return;
	}
	switchx_Cli.dispatch(process.argv.slice(2));
};
switchx_Cli.dispatch = function(args,cb) {
	var scope = haxeshim_Scope.seek({ cwd : HxOverrides.remove(args,"--global") ? haxeshim_Scope.DEFAULT_ROOT : null});
	var api = new switchx_Switchx(scope);
	var log = HxOverrides.remove(args,"--silent") ? function(msg) {
	} : function(msg1) {
		process.stdout.write(msg1);
		process.stdout.write("\n");
	};
	var force = HxOverrides.remove(args,"--force");
	var download = function(version) {
		log("Looking up Haxe version \"" + version + "\"");
		return tink_core__$Promise_Promise_$Impl_$.next(api.resolveOnline(switchx__$Version_UserVersion_$Impl_$.ofString(version)),function(r) {
			log("  Resolved to " + switchx__$Version_ResolvedVersion_$Impl_$.toString(r) + ". Downloading ...");
			return tink_core__$Promise_Promise_$Impl_$.next(api.download(r,{ force : force}),function(wasDownloaded) {
				log(!wasDownloaded ? "  ... already downloaded!" : "  ... download complete!");
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(r));
			});
		});
	};
	var switchTo = function(version1) {
		return tink_core__$Promise_Promise_$Impl_$.next(api.switchTo(version1),function(v) {
			log("Now using " + switchx__$Version_ResolvedVersion_$Impl_$.toString(version1));
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(v));
		});
	};
	var commands = [new switchx_Command("install","[<version>]","installs the version if specified, otherwise\ninstalls the currently configured version",function(args1) {
		switch(args1.length) {
		case 0:
			return tink_core__$Promise_Promise_$Impl_$.next(download(scope.config.version),switchTo);
		case 1:
			return tink_core__$Promise_Promise_$Impl_$.next(download(args1[0]),switchTo);
		default:
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"command `install` accepts one argument at most (i.e. the version)",{ fileName : "Cli.hx", lineNumber : 76, className : "switchx.Cli", methodName : "dispatch"})));
		}
	}),new switchx_Command("download","<version>","downloads the specified version",function(args2) {
		switch(args2.length) {
		case 0:
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"not enough arguments",{ fileName : "Cli.hx", lineNumber : 82, className : "switchx.Cli", methodName : "dispatch"})));
		case 1:
			return tink_core__$Promise_Promise_$Impl_$.noise(download(args2[0]));
		default:
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"too many arguments",{ fileName : "Cli.hx", lineNumber : 83, className : "switchx.Cli", methodName : "dispatch"})));
		}
	}),new switchx_Command("switch","<version>","switches to the specified version",function(args3) {
		switch(args3.length) {
		case 0:
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"not enough arguments",{ fileName : "Cli.hx", lineNumber : 89, className : "switchx.Cli", methodName : "dispatch"})));
		case 1:
			return tink_core__$Promise_Promise_$Impl_$.next(api.resolveInstalled(switchx__$Version_UserVersion_$Impl_$.ofString(args3[0])),switchTo);
		default:
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"too many arguments",{ fileName : "Cli.hx", lineNumber : 90, className : "switchx.Cli", methodName : "dispatch"})));
		}
	}),new switchx_Command("libs","[scoped|mixed|haxelib]","sets library resolution strategy",function(args4) {
		switch(args4.length) {
		case 0:
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"not enough arguments",{ fileName : "Cli.hx", lineNumber : 95, className : "switchx.Cli", methodName : "dispatch"})));
		case 1:
			var v1 = args4[0];
			var _g = new haxe_ds_StringMap();
			var value = null;
			if(__map_reserved["scoped"] != null) {
				_g.setReserved("scoped",value);
			} else {
				_g.h["scoped"] = value;
			}
			var value1 = "mixed";
			if(__map_reserved["mixed"] != null) {
				_g.setReserved("mixed",value1);
			} else {
				_g.h["mixed"] = value1;
			}
			var value2 = "haxelib";
			if(__map_reserved["haxelib"] != null) {
				_g.setReserved("haxelib",value2);
			} else {
				_g.h["haxelib"] = value2;
			}
			if(__map_reserved[v1] != null ? _g.existsReserved(v1) : _g.h.hasOwnProperty(v1)) {
				scope.reconfigure({ version : scope.config.version, resolveLibs : __map_reserved[v1] != null ? _g.getReserved(v1) : _g.h[v1]});
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
			} else {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"unknown strategy " + v1,{ fileName : "Cli.hx", lineNumber : 111, className : "switchx.Cli", methodName : "dispatch"})));
			}
			break;
		default:
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"too many arguments",{ fileName : "Cli.hx", lineNumber : 112, className : "switchx.Cli", methodName : "dispatch"})));
		}
	}),new switchx_Command("scope","[create|delete]","creates or deletes the current scope or\ninspects it if no argument is supplied",function(args5) {
		switch(args5.length) {
		case 0:
			process.stdout.write((scope.isGlobal ? "[global]" : "[local]") + (" " + scope.scopeDir));
			process.stdout.write("\n");
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
		case 1:
			switch(args5[0]) {
			case "create":
				haxeshim_Scope.create(scope.cwd,{ version : scope.config.version, resolveLibs : scope.isGlobal ? null : scope.config.resolveLibs});
				log("created scope in " + scope.cwd);
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
			case "delete":
				if(scope.isGlobal) {
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Cannot delete global scope",{ fileName : "Cli.hx", lineNumber : 126, className : "switchx.Cli", methodName : "dispatch"})));
				} else {
					scope["delete"]();
					log("deleted scope in " + scope.scopeDir);
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
				}
				break;
			default:
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Invalid arguments",{ fileName : "Cli.hx", lineNumber : 139, className : "switchx.Cli", methodName : "dispatch"})));
			}
			break;
		default:
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"Invalid arguments",{ fileName : "Cli.hx", lineNumber : 139, className : "switchx.Cli", methodName : "dispatch"})));
		}
	}),new switchx_Command("list","","lists currently downloaded versions",function(args6) {
		if(args6.length == 0) {
			return tink_core__$Promise_Promise_$Impl_$.next(api.officialInstalled(switchx_PickOfficial.IncludePrereleases),function(o) {
				return tink_core__$Promise_Promise_$Impl_$.next(api.nightliesInstalled(),function(n) {
					var highlight = function(s) {
						if(s == scope.config.version) {
							return " -> " + s;
						} else {
							return "    " + s;
						}
					};
					process.stdout.write("");
					process.stdout.write("\n");
					process.stdout.write("Official releases:");
					process.stdout.write("\n");
					process.stdout.write("");
					process.stdout.write("\n");
					var v2 = $iterator(o)();
					while(v2.hasNext()) {
						var v3 = highlight(v2.next());
						process.stdout.write(v3);
						process.stdout.write("\n");
					}
					if($iterator(n)().hasNext()) {
						process.stdout.write("");
						process.stdout.write("\n");
						process.stdout.write("Nightly builds:");
						process.stdout.write("\n");
						process.stdout.write("");
						process.stdout.write("\n");
						var v4 = $iterator(n)();
						while(v4.hasNext()) {
							var v5 = v4.next();
							var v6 = highlight(v5.hash) + DateTools.format(v5.published,"  (%Y-%m-%d %H:%M)");
							process.stdout.write(v6);
							process.stdout.write("\n");
						}
					}
					process.stdout.write("");
					process.stdout.write("\n");
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
				});
			});
		} else {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(null,"command `list` does expect arguments",{ fileName : "Cli.hx", lineNumber : 176, className : "switchx.Cli", methodName : "dispatch"})));
		}
	})];
	var _g1 = args.shift();
	if(_g1 == null) {
		process.stdout.write("switchx - haxe version switcher");
		process.stdout.write("\n");
		process.stdout.write("");
		process.stdout.write("\n");
		var prefix = 0;
		var _g2 = 0;
		while(_g2 < commands.length) {
			var c = commands[_g2];
			++_g2;
			var cur = c.name.length + c.args.length;
			if(cur > prefix) {
				prefix = cur;
			}
		}
		prefix += 7;
		var _g3 = [];
		var _g21 = 0;
		var _g11 = prefix;
		while(_g21 < _g11) {
			++_g21;
			_g3.push(" ");
		}
		var prefix1 = _g3.join("");
		var pad = function(s1) {
			return StringTools.lpad(s1," ",prefix1.length);
		};
		process.stdout.write("  Supported commands:");
		process.stdout.write("\n");
		process.stdout.write("");
		process.stdout.write("\n");
		var _g12 = 0;
		while(_g12 < commands.length) {
			var c1 = commands[_g12];
			++_g12;
			var v7 = pad("  " + c1.name + " " + c1.args + " : ") + StringTools.replace(c1.doc,"\n","\n" + prefix1);
			process.stdout.write(v7);
			process.stdout.write("\n");
		}
		process.stdout.write("");
		process.stdout.write("\n");
		process.stdout.write("  Supported switches:");
		process.stdout.write("\n");
		process.stdout.write("");
		process.stdout.write("\n");
		var v8 = pad("--silent : ") + "disables logging";
		process.stdout.write(v8);
		process.stdout.write("\n");
		var v9 = pad("--global : ") + "performs operation on global scope";
		process.stdout.write(v9);
		process.stdout.write("\n");
		var v10 = pad("--force : ") + "forces re-download";
		process.stdout.write(v10);
		process.stdout.write("\n");
		process.stdout.write("");
		process.stdout.write("\n");
		process.stdout.write("  Version aliases:");
		process.stdout.write("\n");
		process.stdout.write("");
		process.stdout.write("\n");
		var v11 = pad("edge, nightly : ") + "latest nightly build from builds.haxe.org";
		process.stdout.write(v11);
		process.stdout.write("\n");
		var v12 = pad("latest : ") + "latest official release from haxe.org";
		process.stdout.write(v12);
		process.stdout.write("\n");
		var v13 = pad("stable : ") + "latest stable release from haxe.org";
		process.stdout.write(v13);
		process.stdout.write("\n");
		process.stdout.write("");
		process.stdout.write("\n");
		process.exit(0);
	} else {
		var _g4 = 0;
		while(_g4 < commands.length) {
			var canditate = commands[_g4];
			++_g4;
			if(canditate.name == _g1) {
				canditate.exec(args)(function(o1) {
					if(o1[1] == 1) {
						var e = o1[2];
						process.stderr.write(e.message + "\n\n");
						process.exit(e.code);
					} else {
						if(cb != null) {
							cb();
							return;
						}
						process.exit(0);
					}
				});
				return;
			}
		}
		process.stderr.write("unknown command " + _g1 + "\n\n");
		process.exit(404);
	}
};
var switchx_Command = function(name,args,doc,exec) {
	this.name = name;
	this.args = args;
	this.doc = doc;
	this.exec = exec;
};
switchx_Command.__name__ = true;
switchx_Command.prototype = {
	__class__: switchx_Command
};
var switchx_Download = function() { };
switchx_Download.__name__ = true;
switchx_Download.text = function(url) {
	return tink_core__$Promise_Promise_$Impl_$.next(switchx_Download.bytes(url),function(b) {
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(b.toString()));
	});
};
switchx_Download.bytes = function(url) {
	return switchx_Download.download(url,function(r,cb) {
		var ret = [];
		r.on("data",$bind(ret,$arrayPush));
		r.on("end",function() {
			var tmp = tink_core_Outcome.Success(haxe_io_Bytes.ofData(js_node_buffer_Buffer.concat(ret)));
			cb(tmp);
		});
	});
};
switchx_Download.tar = function(url,peel,into) {
	return tink_core__$Future_Future_$Impl_$.async(function(cb) {
		switchx_Download.download(url,function(res,cb1) {
			res.pipe(js_node_Zlib.createGunzip()).pipe(switchx_Tar.Extract({ path : into, strip : peel})).on("error",function(e) {
				cb1(tink_core_Outcome.Failure(new tink_core_TypedError(422,"Failed to untar " + url + " into " + into + " because " + Std.string(e),{ fileName : "Download.hx", lineNumber : 40, className : "switchx.Download", methodName : "tar"})));
			}).on("close",function() {
				cb1(tink_core_Outcome.Success(into));
			});
		})(cb);
	});
};
switchx_Download.zip = function(url,peel,into) {
	return tink_core__$Promise_Promise_$Impl_$.next(switchx_Download.bytes(url),function(bytes) {
		return tink_core__$Future_Future_$Impl_$.async(function(cb) {
			var count = 1;
			var done = function() {
				haxe_Timer.delay(function() {
					if((count -= 1) == 0) {
						cb(tink_core_Outcome.Success(into));
					}
				},100);
			};
			switchx_Yauzl.fromBuffer(new js_node_buffer_Buffer(bytes.b.bufferValue),function(err,zip) {
				if(err != null) {
					cb(tink_core_Outcome.Failure(new tink_core_TypedError(422,"Failed to unzip " + url,{ fileName : "Download.hx", lineNumber : 58, className : "switchx.Download", methodName : "zip"})));
				}
				zip.on("entry",function(entry) {
					var _g = switchx_Fs.peel(entry.fileName,peel);
					switch(_g[1]) {
					case 0:
						var path = "" + into + "/" + _g[2];
						if(!StringTools.endsWith(path,"/")) {
							switchx_Fs.ensureDir(path);
							zip.openReadStream(entry,function(e,stream) {
								count += 1;
								var out = js_node_Fs.createWriteStream(path);
								stream.pipe(out,{ end : true});
								out.on("close",done);
							});
						}
						break;
					case 1:
						break;
					}
				});
				zip.on("end",function() {
					zip.close();
					done();
				});
			});
		});
	});
};
switchx_Download.download = function(url,handler) {
	return tink_core__$Future_Future_$Impl_$.async(function(cb) {
		var options = js_node_Url.parse(url);
		options.agent = false;
		var fail = function(e) {
			var fail1 = tink_core_Outcome.Failure(tink_core_TypedError.withData(null,"Failed to download " + url + " because " + e.message,e,{ fileName : "Download.hx", lineNumber : 90, className : "switchx.Download", methodName : "download"}));
			cb(fail1);
		};
		var req = StringTools.startsWith(url,"https:") ? js_node_Https.get(options) : js_node_Http.get(options);
		req.setTimeout(30000);
		req.on("error",fail);
		req.on("response",function(res) {
			res.on("error",fail);
			handler(res,function(v) {
				switch(v[1]) {
				case 0:
					cb(tink_core_Outcome.Success(v[2]));
					break;
				case 1:
					cb(tink_core_Outcome.Failure(v[2]));
					break;
				}
			});
		});
	});
};
var switchx_Fs = function() { };
switchx_Fs.__name__ = true;
switchx_Fs.ensureDir = function(dir) {
	var isDir = StringTools.endsWith(dir,"/") || StringTools.endsWith(dir,"\\");
	if(isDir) {
		dir = haxe_io_Path.removeTrailingSlashes(dir);
	}
	var parent = haxe_io_Path.directory(dir);
	if(haxe_io_Path.removeTrailingSlashes(parent) == dir) {
		return;
	}
	if(!sys_FileSystem.exists(parent)) {
		switchx_Fs.ensureDir(haxe_io_Path.addTrailingSlash(parent));
	}
	if(isDir && !sys_FileSystem.exists(dir)) {
		sys_FileSystem.createDirectory(dir);
	}
};
switchx_Fs.peel = function(file,depth) {
	var start = 0;
	var _g1 = 0;
	while(_g1 < depth) {
		++_g1;
		var _g2 = file.indexOf("/",start);
		if(_g2 == -1) {
			return haxe_ds_Option.None;
		} else {
			start = _g2 + 1;
		}
	}
	return haxe_ds_Option.Some(HxOverrides.substr(file,start,null));
};
var switchx_PickOfficial = { __ename__ : true, __constructs__ : ["StableOnly","IncludePrereleases"] };
switchx_PickOfficial.StableOnly = ["StableOnly",0];
switchx_PickOfficial.StableOnly.toString = $estr;
switchx_PickOfficial.StableOnly.__enum__ = switchx_PickOfficial;
switchx_PickOfficial.IncludePrereleases = ["IncludePrereleases",1];
switchx_PickOfficial.IncludePrereleases.toString = $estr;
switchx_PickOfficial.IncludePrereleases.__enum__ = switchx_PickOfficial;
var switchx_Switchx = function(scope) {
	this.scope = scope;
	switchx_Fs.ensureDir(this.versions = "" + this.get_root() + "/versions/");
	switchx_Fs.ensureDir(this.downloads = "" + this.get_root() + "/downloads/");
	switchx_Fs.ensureDir(this.haxelibs = "" + this.get_root() + "/haxelibs/");
};
switchx_Switchx.__name__ = true;
switchx_Switchx.linkToNightly = function(hash,date) {
	return DateTools.format(date,"" + switchx_Switchx.NIGHTLIES + "/" + switchx_Switchx.PLATFORM + "/haxe_%Y-%m-%d_development_" + hash + ".tar.gz");
};
switchx_Switchx.sortedOfficial = function(kind,versions) {
	if(kind == switchx_PickOfficial.StableOnly) {
		var _g = [];
		var _g1 = 0;
		while(_g1 < versions.length) {
			var v = versions[_g1];
			++_g1;
			if(!switchx__$Version_Official_$Impl_$.get_isPrerelease(v)) {
				_g.push(v);
			}
		}
		versions = _g;
	}
	versions.sort(switchx__$Version_Official_$Impl_$.compare);
	return versions;
};
switchx_Switchx.officialOnline = function(kind) {
	return tink_core__$Promise_Promise_$Impl_$.next(switchx_Download.text("https://raw.githubusercontent.com/HaxeFoundation/haxe.org/staging/downloads/versions.json"),function(s) {
		var d = JSON.parse(s).versions.map(function(v) {
			return v.version;
		});
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(switchx_Switchx.sortedOfficial(kind,d)));
	});
};
switchx_Switchx.sortedNightlies = function(raw) {
	raw.sort(function(a,b) {
		return Reflect.compare(b.published.getTime(),a.published.getTime());
	});
	return raw;
};
switchx_Switchx.nightliesOnline = function() {
	return tink_core__$Promise_Promise_$Impl_$.next(switchx_Download.text("" + switchx_Switchx.NIGHTLIES + "/" + switchx_Switchx.PLATFORM + "/"),tink_core__$Promise_Next_$Impl_$.ofSafeSync(function(s) {
		var lines = s.split("------------------\n").pop().split("\n");
		var ret = [];
		var _g = 0;
		while(_g < lines.length) {
			var l = lines[_g];
			++_g;
			var _g1 = StringTools.trim(l);
			if(_g1 != "") {
				if(_g1.indexOf("_development_") != -1) {
					var _g11 = _g1.indexOf("   ");
					var _hx_tmp;
					if(_g11 != -1) {
						_hx_tmp = HxOverrides.substr(_g1,0,_g11).split(" ");
						if(_hx_tmp.length == 2) {
							var _hx_tmp1 = _hx_tmp[0].split("-").map(Std.parseInt);
							if(_hx_tmp1.length == 3) {
								if(_hx_tmp1[0] == null) {
									if(_hx_tmp1[1] == null) {
										if(_hx_tmp1[2] == null) {
											var _hx_tmp2 = _hx_tmp[1].split(":").map(Std.parseInt);
											if(_hx_tmp2.length == 2) {
												var mm = _hx_tmp2[1];
												var hh = _hx_tmp2[0];
												var y = _hx_tmp1[0];
												var m = _hx_tmp1[1];
												var d = _hx_tmp1[2];
												ret.push({ hash : _g1.split("_development_").pop().split(".").shift(), published : new Date(y,m - 1,d,hh,mm,0)});
											}
										} else {
											var _hx_tmp3 = _hx_tmp[1].split(":").map(Std.parseInt);
											if(_hx_tmp3.length == 2) {
												var mm1 = _hx_tmp3[1];
												var hh1 = _hx_tmp3[0];
												var y1 = _hx_tmp1[0];
												var m1 = _hx_tmp1[1];
												var d1 = _hx_tmp1[2];
												ret.push({ hash : _g1.split("_development_").pop().split(".").shift(), published : new Date(y1,m1 - 1,d1,hh1,mm1,0)});
											}
										}
									} else if(_hx_tmp1[2] == null) {
										var _hx_tmp4 = _hx_tmp[1].split(":").map(Std.parseInt);
										if(_hx_tmp4.length == 2) {
											var mm2 = _hx_tmp4[1];
											var hh2 = _hx_tmp4[0];
											var y2 = _hx_tmp1[0];
											var m2 = _hx_tmp1[1];
											var d2 = _hx_tmp1[2];
											ret.push({ hash : _g1.split("_development_").pop().split(".").shift(), published : new Date(y2,m2 - 1,d2,hh2,mm2,0)});
										}
									} else {
										var _hx_tmp5 = _hx_tmp[1].split(":").map(Std.parseInt);
										if(_hx_tmp5.length == 2) {
											var mm3 = _hx_tmp5[1];
											var hh3 = _hx_tmp5[0];
											var y3 = _hx_tmp1[0];
											var m3 = _hx_tmp1[1];
											var d3 = _hx_tmp1[2];
											ret.push({ hash : _g1.split("_development_").pop().split(".").shift(), published : new Date(y3,m3 - 1,d3,hh3,mm3,0)});
										}
									}
								} else if(_hx_tmp1[1] == null) {
									if(_hx_tmp1[2] == null) {
										var _hx_tmp6 = _hx_tmp[1].split(":").map(Std.parseInt);
										if(_hx_tmp6.length == 2) {
											var mm4 = _hx_tmp6[1];
											var hh4 = _hx_tmp6[0];
											var y4 = _hx_tmp1[0];
											var m4 = _hx_tmp1[1];
											var d4 = _hx_tmp1[2];
											ret.push({ hash : _g1.split("_development_").pop().split(".").shift(), published : new Date(y4,m4 - 1,d4,hh4,mm4,0)});
										}
									} else {
										var _hx_tmp7 = _hx_tmp[1].split(":").map(Std.parseInt);
										if(_hx_tmp7.length == 2) {
											var mm5 = _hx_tmp7[1];
											var hh5 = _hx_tmp7[0];
											var y5 = _hx_tmp1[0];
											var m5 = _hx_tmp1[1];
											var d5 = _hx_tmp1[2];
											ret.push({ hash : _g1.split("_development_").pop().split(".").shift(), published : new Date(y5,m5 - 1,d5,hh5,mm5,0)});
										}
									}
								} else if(_hx_tmp1[2] == null) {
									var _hx_tmp8 = _hx_tmp[1].split(":").map(Std.parseInt);
									if(_hx_tmp8.length == 2) {
										var mm6 = _hx_tmp8[1];
										var hh6 = _hx_tmp8[0];
										var y6 = _hx_tmp1[0];
										var m6 = _hx_tmp1[1];
										var d6 = _hx_tmp1[2];
										ret.push({ hash : _g1.split("_development_").pop().split(".").shift(), published : new Date(y6,m6 - 1,d6,hh6,mm6,0)});
									}
								} else {
									var _hx_tmp9 = _hx_tmp[1].split(":").map(Std.parseInt);
									if(_hx_tmp9.length == 2) {
										var mm7 = _hx_tmp9[1];
										var hh7 = _hx_tmp9[0];
										var y7 = _hx_tmp1[0];
										var m7 = _hx_tmp1[1];
										var d7 = _hx_tmp1[2];
										ret.push({ hash : _g1.split("_development_").pop().split(".").shift(), published : new Date(y7,m7 - 1,d7,hh7,mm7,0)});
									}
								}
							}
						}
					}
				}
			}
		}
		return switchx_Switchx.sortedNightlies(ret);
	}));
};
switchx_Switchx.attempt = function(what,l) {
	var o;
	try {
		o = tink_core_Outcome.Success(l());
	} catch( e ) {
		if (e instanceof js__$Boot_HaxeError) e = e.val;
		o = tink_core_Outcome.Failure(new tink_core_TypedError(null,"Failed to " + what + " because " + Std.string(e),{ fileName : "Switchx.hx", lineNumber : 108, className : "switchx.Switchx", methodName : "attempt"}));
	}
	return tink_core__$Future_Future_$Impl_$.sync(o);
};
switchx_Switchx.pickFirst = function(kind,make) {
	return function(i) {
		var _g = $iterator(i)().next();
		if(_g == null) {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(404,"No " + kind + " build found",{ fileName : "Switchx.hx", lineNumber : 139, className : "switchx.Switchx", methodName : "pickFirst"})));
		} else {
			return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(make(_g)));
		}
	};
};
switchx_Switchx.prototype = {
	get_root: function() {
		return this.scope.haxeshimRoot;
	}
	,officialInstalled: function(kind) {
		var _g = [];
		var _g1 = 0;
		var _g2 = js_node_Fs.readdirSync(this.versions);
		while(_g1 < _g2.length) {
			var v = _g2[_g1];
			++_g1;
			if(!switchx__$Version_UserVersion_$Impl_$.isHash(v) && js_node_Fs.statSync("" + this.versions + "/" + v).isDirectory()) {
				_g.push(v);
			}
		}
		var c = switchx_Switchx.sortedOfficial(kind,_g);
		return switchx_Switchx.attempt("Get installed Haxe versions",function() {
			return c;
		});
	}
	,nightliesInstalled: function() {
		var _g = [];
		var _g1 = 0;
		var _g2 = js_node_Fs.readdirSync(this.versions).filter(switchx__$Version_UserVersion_$Impl_$.isHash);
		while(_g1 < _g2.length) {
			var v = _g2[_g1];
			++_g1;
			_g.push({ hash : v, published : HxOverrides.strDate(JSON.parse(js_node_Fs.readFileSync("" + this.versions + "/" + v + "/" + switchx_Switchx.VERSION_INFO,{ encoding : "utf8"})).published)});
		}
		var c = switchx_Switchx.sortedNightlies(_g);
		return switchx_Switchx.attempt("get installed Haxe versions",function() {
			return c;
		});
	}
	,switchTo: function(version) {
		var _gthis = this;
		return switchx_Switchx.attempt("save new configuration to " + this.scope.configFile,tink_core__$Lazy_Lazy_$Impl_$.ofFunc(function() {
			_gthis.scope.reconfigure({ version : switchx__$Version_ResolvedVersion_$Impl_$.get_id(version), resolveLibs : _gthis.scope.config.resolveLibs});
			return tink_core_Noise.Noise;
		}));
	}
	,resolveInstalled: function(version) {
		return this.resolve(version,$bind(this,this.officialInstalled),$bind(this,this.nightliesInstalled));
	}
	,resolveOnline: function(version) {
		return this.resolve(version,switchx_Switchx.officialOnline,switchx_Switchx.nightliesOnline);
	}
	,resolve: function(version,getOfficial,getNightlies) {
		switch(version[1]) {
		case 0:
			return tink_core__$Promise_Promise_$Impl_$.next(getNightlies(),switchx_Switchx.pickFirst("nightly",switchx_ResolvedUserVersionData.RNightly));
		case 1:
			return tink_core__$Promise_Promise_$Impl_$.next(getOfficial(switchx_PickOfficial.IncludePrereleases),switchx_Switchx.pickFirst("official",switchx_ResolvedUserVersionData.ROfficial));
		case 2:
			return tink_core__$Promise_Promise_$Impl_$.next(getOfficial(switchx_PickOfficial.StableOnly),switchx_Switchx.pickFirst("stable",switchx_ResolvedUserVersionData.ROfficial));
		case 3:
			var hash = version[2];
			return tink_core__$Promise_Promise_$Impl_$.ofSpecific(tink_core__$Promise_Promise_$Impl_$.next(getNightlies(),function(v) {
				var n = $iterator(v)();
				while(n.hasNext()) {
					var n1 = n.next();
					if(n1.hash == hash) {
						return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(switchx_ResolvedUserVersionData.RNightly(n1)));
					}
				}
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(404,"Unknown nightly " + Std.string(version),{ fileName : "Switchx.hx", lineNumber : 164, className : "switchx.Switchx", methodName : "resolve"})));
			}));
		case 4:
			var version1 = version[2];
			return tink_core__$Promise_Promise_$Impl_$.ofSpecific(tink_core__$Promise_Promise_$Impl_$.next(getOfficial(switchx_PickOfficial.IncludePrereleases),function(versions) {
				if(Lambda.has(versions,version1)) {
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(switchx_ResolvedUserVersionData.ROfficial(version1)));
				} else {
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Failure(new tink_core_TypedError(404,"Unknown version " + version1,{ fileName : "Switchx.hx", lineNumber : 172, className : "switchx.Switchx", methodName : "resolve"})));
				}
			}));
		}
	}
	,isDownloaded: function(r) {
		return sys_FileSystem.exists("" + this.versions + "/" + switchx__$Version_ResolvedVersion_$Impl_$.get_id(r));
	}
	,linkToOfficial: function(version) {
		var tmp = "http://haxe.org/website-content/downloads/" + version + "/downloads/haxe-" + version + "-";
		var tmp1;
		switch(Sys.systemName()) {
		case "Mac":
			tmp1 = "osx.tar.gz";
			break;
		case "Windows":
			tmp1 = "win.zip";
			break;
		default:
			tmp1 = "linux64.tar.gz";
		}
		return tmp + tmp1;
	}
	,replace: function(target,replacement,archiveAs) {
		if(sys_FileSystem.exists(target)) {
			js_node_Fs.renameSync(target,"" + this.downloads + "/" + archiveAs + "@" + Math.floor(js_node_Fs.statSync(target).ctime.getTime()));
			js_node_Fs.renameSync(replacement,target);
		} else {
			js_node_Fs.renameSync(replacement,target);
		}
	}
	,download: function(version,options) {
		var _gthis = this;
		if(this.isDownloaded(version) == true) {
			if(options.force != true) {
				return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(false));
			} else {
				switch(version[1]) {
				case 0:
					var date = version[2].published;
					var hash = version[2].hash;
					return tink_core__$Promise_Promise_$Impl_$.next(switchx_Download.tar(switchx_Switchx.linkToNightly(hash,date),1,"" + this.downloads + "/" + hash + "@" + Math.floor(new Date().getTime())),function(dir) {
						js_node_Fs.writeFileSync("" + dir + "/" + switchx_Switchx.VERSION_INFO,JSON.stringify({ published : HxOverrides.dateStr(date)}));
						_gthis.replace("" + _gthis.versions + "/" + hash,dir,hash);
						return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(true));
					});
				case 1:
					var version1 = version[2];
					var url = this.linkToOfficial(version1);
					var tmp = "" + this.downloads + "/" + version1 + "@" + Math.floor(new Date().getTime());
					return tink_core__$Promise_Promise_$Impl_$.next(haxe_io_Path.extension(url) == "zip" ? switchx_Download.zip(url,1,tmp) : switchx_Download.tar(url,1,tmp),function(dir1) {
						_gthis.replace("" + _gthis.versions + "/" + version1,dir1,version1);
						return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(true));
					});
				}
			}
		} else {
			switch(version[1]) {
			case 0:
				var date1 = version[2].published;
				var hash1 = version[2].hash;
				return tink_core__$Promise_Promise_$Impl_$.next(switchx_Download.tar(switchx_Switchx.linkToNightly(hash1,date1),1,"" + this.downloads + "/" + hash1 + "@" + Math.floor(new Date().getTime())),function(dir2) {
					js_node_Fs.writeFileSync("" + dir2 + "/" + switchx_Switchx.VERSION_INFO,JSON.stringify({ published : HxOverrides.dateStr(date1)}));
					_gthis.replace("" + _gthis.versions + "/" + hash1,dir2,hash1);
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(true));
				});
			case 1:
				var version2 = version[2];
				var url1 = this.linkToOfficial(version2);
				var tmp1 = "" + this.downloads + "/" + version2 + "@" + Math.floor(new Date().getTime());
				return tink_core__$Promise_Promise_$Impl_$.next(haxe_io_Path.extension(url1) == "zip" ? switchx_Download.zip(url1,1,tmp1) : switchx_Download.tar(url1,1,tmp1),function(dir3) {
					_gthis.replace("" + _gthis.versions + "/" + version2,dir3,version2);
					return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(true));
				});
			}
		}
	}
	,__class__: switchx_Switchx
};
var switchx_Tar = require("tar");
var switchx_UserVersionData = { __ename__ : true, __constructs__ : ["UEdge","ULatest","UStable","UNightly","UOfficial"] };
switchx_UserVersionData.UEdge = ["UEdge",0];
switchx_UserVersionData.UEdge.toString = $estr;
switchx_UserVersionData.UEdge.__enum__ = switchx_UserVersionData;
switchx_UserVersionData.ULatest = ["ULatest",1];
switchx_UserVersionData.ULatest.toString = $estr;
switchx_UserVersionData.ULatest.__enum__ = switchx_UserVersionData;
switchx_UserVersionData.UStable = ["UStable",2];
switchx_UserVersionData.UStable.toString = $estr;
switchx_UserVersionData.UStable.__enum__ = switchx_UserVersionData;
switchx_UserVersionData.UNightly = function(hash) { var $x = ["UNightly",3,hash]; $x.__enum__ = switchx_UserVersionData; $x.toString = $estr; return $x; };
switchx_UserVersionData.UOfficial = function(version) { var $x = ["UOfficial",4,version]; $x.__enum__ = switchx_UserVersionData; $x.toString = $estr; return $x; };
var switchx__$Version_Official_$Impl_$ = {};
switchx__$Version_Official_$Impl_$.__name__ = true;
switchx__$Version_Official_$Impl_$.get_isPrerelease = function(this1) {
	return this1.indexOf("-") != -1;
};
switchx__$Version_Official_$Impl_$.compare = function(a,b) {
	return Reflect.compare(b,a);
};
var switchx_ResolvedUserVersionData = { __ename__ : true, __constructs__ : ["RNightly","ROfficial"] };
switchx_ResolvedUserVersionData.RNightly = function(nightly) { var $x = ["RNightly",0,nightly]; $x.__enum__ = switchx_ResolvedUserVersionData; $x.toString = $estr; return $x; };
switchx_ResolvedUserVersionData.ROfficial = function(version) { var $x = ["ROfficial",1,version]; $x.__enum__ = switchx_ResolvedUserVersionData; $x.toString = $estr; return $x; };
var switchx__$Version_ResolvedVersion_$Impl_$ = {};
switchx__$Version_ResolvedVersion_$Impl_$.__name__ = true;
switchx__$Version_ResolvedVersion_$Impl_$.get_id = function(this1) {
	switch(this1[1]) {
	case 0:
		return this1[2].hash;
	case 1:
		return this1[2];
	}
};
switchx__$Version_ResolvedVersion_$Impl_$.toString = function(this1) {
	switch(this1[1]) {
	case 0:
		return "nightly build " + this1[2].hash;
	case 1:
		return "official release " + this1[2];
	}
};
var switchx__$Version_UserVersion_$Impl_$ = {};
switchx__$Version_UserVersion_$Impl_$.__name__ = true;
switchx__$Version_UserVersion_$Impl_$.isHash = function(version) {
	var _g1 = 0;
	var _g = version.length;
	while(_g1 < _g) {
		var this1 = switchx__$Version_UserVersion_$Impl_$.hex;
		var key = version.charCodeAt(_g1++);
		if(!this1.h[key]) {
			return false;
		}
	}
	return true;
};
switchx__$Version_UserVersion_$Impl_$.ofString = function(s) {
	if(s == null) {
		return null;
	} else {
		var _hx_tmp;
		if(s == null) {
			_hx_tmp = switchx__$Version_UserVersion_$Impl_$.isHash(s);
			if(_hx_tmp == true) {
				return switchx_UserVersionData.UNightly(s);
			} else {
				return switchx_UserVersionData.UOfficial(s);
			}
		} else {
			switch(s) {
			case "auto":
				return null;
			case "latest":
				return switchx_UserVersionData.ULatest;
			case "edge":case "nightly":
				return switchx_UserVersionData.UEdge;
			case "stable":
				return switchx_UserVersionData.UStable;
			default:
				_hx_tmp = switchx__$Version_UserVersion_$Impl_$.isHash(s);
				if(_hx_tmp == true) {
					return switchx_UserVersionData.UNightly(s);
				} else {
					return switchx_UserVersionData.UOfficial(s);
				}
			}
		}
	}
};
var switchx_Yauzl = require("yauzl");
var sys_FileSystem = function() { };
sys_FileSystem.__name__ = true;
sys_FileSystem.exists = function(path) {
	try {
		js_node_Fs.accessSync(path);
		return true;
	} catch( _ ) {
		return false;
	}
};
sys_FileSystem.createDirectory = function(path) {
	try {
		js_node_Fs.mkdirSync(path);
	} catch( e ) {
		if (e instanceof js__$Boot_HaxeError) e = e.val;
		if(e.code == "ENOENT") {
			sys_FileSystem.createDirectory(js_node_Path.dirname(path));
			js_node_Fs.mkdirSync(path);
		} else {
			var stat;
			try {
				stat = js_node_Fs.statSync(path);
			} catch( _ ) {
				throw e;
			}
			if(!stat.isDirectory()) {
				throw e;
			}
		}
	}
};
var tink_core__$Callback_Callback_$Impl_$ = {};
tink_core__$Callback_Callback_$Impl_$.__name__ = true;
tink_core__$Callback_Callback_$Impl_$.defer = function(f) {
	process.nextTick(f);
};
var tink_core__$Callback_CallbackList_$Impl_$ = {};
tink_core__$Callback_CallbackList_$Impl_$.__name__ = true;
tink_core__$Callback_CallbackList_$Impl_$.add = function(this1,cb) {
	var ret = new Array(1);
	ret[0] = cb;
	var cell = ret;
	this1.push(cell);
	return function() {
		if(HxOverrides.remove(this1,cell)) {
			cell[0] = null;
		}
		cell = null;
	};
};
tink_core__$Callback_CallbackList_$Impl_$.invoke = function(this1,data) {
	var _g = 0;
	var _g1 = this1.slice();
	while(_g < _g1.length) {
		var cell = _g1[_g];
		++_g;
		if(cell[0] != null) {
			cell[0](data);
		}
	}
};
tink_core__$Callback_CallbackList_$Impl_$.clear = function(this1) {
	var _g = 0;
	var _g1 = this1.splice(0,this1.length);
	while(_g < _g1.length) {
		var cell = _g1[_g];
		++_g;
		cell[0] = null;
	}
};
var tink_core_TypedError = function(code,message,pos) {
	if(code == null) {
		code = 500;
	}
	this.code = code;
	this.message = message;
	this.pos = pos;
	this.exceptionStack = [];
	this.callStack = [];
};
tink_core_TypedError.__name__ = true;
tink_core_TypedError.withData = function(code,message,data,pos) {
	return tink_core_TypedError.typed(code,message,data,pos);
};
tink_core_TypedError.typed = function(code,message,data,pos) {
	var ret = new tink_core_TypedError(code,message,pos);
	ret.data = data;
	return ret;
};
tink_core_TypedError.catchExceptions = function(f,report,pos) {
	try {
		return tink_core_Outcome.Success(f());
	} catch( $e0 ) {
		if ($e0 instanceof js__$Boot_HaxeError) $e0 = $e0.val;
		if( js_Boot.__instanceof($e0,tink_core_TypedError) ) {
			var e = $e0;
			return tink_core_Outcome.Failure(e);
		} else {
		var e1 = $e0;
		return tink_core_Outcome.Failure(report == null ? tink_core_TypedError.withData(null,"Unexpected Error",e1,pos) : report(e1));
		}
	}
};
tink_core_TypedError.reporter = function(code,message,pos) {
	return function(e) {
		return tink_core_TypedError.withData(code,message,e,pos);
	};
};
tink_core_TypedError.rethrow = function(any) {
	throw js__$Boot_HaxeError.wrap(any);
};
tink_core_TypedError.prototype = {
	printPos: function() {
		return this.pos.className + "." + this.pos.methodName + ":" + this.pos.lineNumber;
	}
	,toString: function() {
		var ret = "Error#" + this.code + ": " + this.message;
		if(this.pos != null) {
			ret += " @ " + this.printPos();
		}
		return ret;
	}
	,throwSelf: function() {
		throw new js__$Boot_HaxeError(this);
	}
	,__class__: tink_core_TypedError
};
var tink_core__$Future_Future_$Impl_$ = {};
tink_core__$Future_Future_$Impl_$.__name__ = true;
tink_core__$Future_Future_$Impl_$._new = function(f) {
	return f;
};
tink_core__$Future_Future_$Impl_$.gather = function(this1) {
	var op = new tink_core_FutureTrigger();
	var self = this1;
	return tink_core__$Future_Future_$Impl_$._new(function(cb) {
		if(self != null) {
			this1($bind(op,op.trigger));
			self = null;
		}
		return op.future(cb);
	});
};
tink_core__$Future_Future_$Impl_$.map = function(this1,f,gather) {
	if(gather == null) {
		gather = true;
	}
	var ret = tink_core__$Future_Future_$Impl_$._new(function(callback) {
		return this1(function(result) {
			var data = f(result);
			callback(data);
		});
	});
	if(gather) {
		return tink_core__$Future_Future_$Impl_$.gather(ret);
	} else {
		return ret;
	}
};
tink_core__$Future_Future_$Impl_$.flatMap = function(this1,next,gather) {
	if(gather == null) {
		gather = true;
	}
	var ret = tink_core__$Future_Future_$Impl_$.flatten(tink_core__$Future_Future_$Impl_$.map(this1,next,gather));
	if(gather) {
		return tink_core__$Future_Future_$Impl_$.gather(ret);
	} else {
		return ret;
	}
};
tink_core__$Future_Future_$Impl_$.flatten = function(f) {
	return tink_core__$Future_Future_$Impl_$._new(function(callback) {
		var ret = null;
		ret = f(function(next) {
			ret = next(function(result) {
				callback(result);
			});
		});
		return ret;
	});
};
tink_core__$Future_Future_$Impl_$.lazy = function(l) {
	return tink_core__$Future_Future_$Impl_$._new(function(cb) {
		cb(l());
		return null;
	});
};
tink_core__$Future_Future_$Impl_$.sync = function(v) {
	return tink_core__$Future_Future_$Impl_$._new(function(callback) {
		callback(v);
		return null;
	});
};
tink_core__$Future_Future_$Impl_$.async = function(f,lazy) {
	if(lazy == null) {
		lazy = false;
	}
	if(lazy) {
		var f1 = f;
		return tink_core__$Future_Future_$Impl_$.flatten(tink_core__$Future_Future_$Impl_$.lazy(tink_core__$Lazy_Lazy_$Impl_$.ofFunc(function() {
			return tink_core__$Future_Future_$Impl_$.async(f1,false);
		})));
	} else {
		var op = new tink_core_FutureTrigger();
		f($bind(op,op.trigger));
		return op.future;
	}
};
tink_core__$Future_Future_$Impl_$._tryFailingFlatMap = function(f,map) {
	return tink_core__$Future_Future_$Impl_$.flatMap(f,function(o) {
		switch(o[1]) {
		case 0:
			return map(o[2]);
		case 1:
			return tink_core__$Future_Future_$Impl_$.sync(tink_core_Outcome.Failure(o[2]));
		}
	});
};
var tink_core_FutureTrigger = function() {
	var _gthis = this;
	this.list = [];
	this.future = tink_core__$Future_Future_$Impl_$._new(function(callback) {
		if(_gthis.list == null) {
			callback(_gthis.result);
			return null;
		} else {
			return tink_core__$Callback_CallbackList_$Impl_$.add(_gthis.list,callback);
		}
	});
};
tink_core_FutureTrigger.__name__ = true;
tink_core_FutureTrigger.prototype = {
	trigger: function(result) {
		if(this.list == null) {
			return false;
		} else {
			var list = this.list;
			this.list = null;
			this.result = result;
			if(tink_core_FutureTrigger.depth >= 1000) {
				tink_core__$Callback_Callback_$Impl_$.defer(function() {
					tink_core_FutureTrigger.depth++;
					tink_core__$Callback_CallbackList_$Impl_$.invoke(list,result);
					tink_core__$Callback_CallbackList_$Impl_$.clear(list);
					tink_core_FutureTrigger.depth--;
				});
			} else {
				tink_core_FutureTrigger.depth++;
				tink_core__$Callback_CallbackList_$Impl_$.invoke(list,result);
				tink_core__$Callback_CallbackList_$Impl_$.clear(list);
				tink_core_FutureTrigger.depth--;
			}
			return true;
		}
	}
	,__class__: tink_core_FutureTrigger
};
var tink_core__$Lazy_Lazy_$Impl_$ = {};
tink_core__$Lazy_Lazy_$Impl_$.__name__ = true;
tink_core__$Lazy_Lazy_$Impl_$.ofFunc = function(f) {
	var result = null;
	return function() {
		if(f != null) {
			result = f();
			f = null;
		}
		return result;
	};
};
var tink_core_Noise = { __ename__ : true, __constructs__ : ["Noise"] };
tink_core_Noise.Noise = ["Noise",0];
tink_core_Noise.Noise.toString = $estr;
tink_core_Noise.Noise.__enum__ = tink_core_Noise;
var tink_core_Outcome = { __ename__ : true, __constructs__ : ["Success","Failure"] };
tink_core_Outcome.Success = function(data) { var $x = ["Success",0,data]; $x.__enum__ = tink_core_Outcome; $x.toString = $estr; return $x; };
tink_core_Outcome.Failure = function(failure) { var $x = ["Failure",1,failure]; $x.__enum__ = tink_core_Outcome; $x.toString = $estr; return $x; };
var tink_core__$Promise_Promise_$Impl_$ = {};
tink_core__$Promise_Promise_$Impl_$.__name__ = true;
tink_core__$Promise_Promise_$Impl_$.noise = function(this1) {
	return tink_core__$Promise_Promise_$Impl_$.next(this1,function(v) {
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(tink_core_Noise.Noise));
	});
};
tink_core__$Promise_Promise_$Impl_$.next = function(this1,f) {
	return tink_core__$Future_Future_$Impl_$._tryFailingFlatMap(this1,function(result) {
		return f(result);
	});
};
tink_core__$Promise_Promise_$Impl_$.ofSpecific = function(s) {
	return s;
};
tink_core__$Promise_Promise_$Impl_$.ofOutcome = function(o) {
	return tink_core__$Future_Future_$Impl_$.sync(o);
};
var tink_core__$Promise_Next_$Impl_$ = {};
tink_core__$Promise_Next_$Impl_$.__name__ = true;
tink_core__$Promise_Next_$Impl_$.ofSafeSync = function(f) {
	return function(x) {
		return tink_core__$Promise_Promise_$Impl_$.ofOutcome(tink_core_Outcome.Success(f(x)));
	};
};
function $iterator(o) { if( o instanceof Array ) return function() { return HxOverrides.iter(o); }; return typeof(o.iterator) == 'function' ? $bind(o,o.iterator) : o.iterator; }
var $_, $fid = 0;
function $bind(o,m) { if( m == null ) return null; if( m.__id__ == null ) m.__id__ = $fid++; var f; if( o.hx__closures__ == null ) o.hx__closures__ = {}; else f = o.hx__closures__[m.__id__]; if( f == null ) { f = function(){ return f.method.apply(f.scope, arguments); }; f.scope = o; f.method = m; o.hx__closures__[m.__id__] = f; } return f; }
function $arrayPush(x) { this.push(x); }
String.prototype.__class__ = String;
String.__name__ = true;
Array.__name__ = true;
Date.prototype.__class__ = Date;
Date.__name__ = ["Date"];
var Int = { __name__ : ["Int"]};
var Dynamic = { __name__ : ["Dynamic"]};
var Float = Number;
Float.__name__ = ["Float"];
var Bool = Boolean;
Bool.__ename__ = ["Bool"];
var Class = { __name__ : ["Class"]};
var Enum = { };
var __map_reserved = {}
DateTools.DAY_SHORT_NAMES = ["Sun","Mon","Tue","Wed","Thu","Fri","Sat"];
DateTools.DAY_NAMES = ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];
DateTools.MONTH_SHORT_NAMES = ["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];
DateTools.MONTH_NAMES = ["January","February","March","April","May","June","July","August","September","October","November","December"];
haxeshim_Scope.IS_WINDOWS = Sys.systemName() == "Windows";
haxeshim_Scope.CONFIG_FILE = ".haxerc";
haxeshim_Scope.DEFAULT_ROOT = (function($this) {
	var $r;
	var _g = process.env["HAXESHIM_ROOT"];
	$r = _g == null ? process.env[haxeshim_Scope.IS_WINDOWS ? "APPDATA" : "HOME"] + "/haxe" : _g == "" ? process.env[haxeshim_Scope.IS_WINDOWS ? "APPDATA" : "HOME"] + "/haxe" : _g;
	return $r;
}(this));
haxeshim_HaxeInstallation.EXT = haxeshim_Scope.IS_WINDOWS ? ".exe" : "";
js_Boot.__toStr = ({ }).toString;
switchx_Switchx.VERSION_INFO = "version.json";
switchx_Switchx.NIGHTLIES = "http://hxbuilds.s3-website-us-east-1.amazonaws.com/builds/haxe";
switchx_Switchx.PLATFORM = (function($this) {
	var $r;
	switch(Sys.systemName()) {
	case "Mac":
		$r = "mac";
		break;
	case "Windows":
		$r = "windows";
		break;
	default:
		$r = "linux64";
	}
	return $r;
}(this));
switchx__$Version_UserVersion_$Impl_$.hex = (function($this) {
	var $r;
	var _g = new haxe_ds_IntMap();
	{
		var _g1 = 0;
		var _g2 = "0123456789abcdefABCDEF".split("");
		while(_g1 < _g2.length) {
			var c = _g2[_g1];
			++_g1;
			var key = HxOverrides.cca(c,0);
			_g.h[key] = true;
		}
	}
	$r = _g;
	return $r;
}(this));
tink_core_FutureTrigger.depth = 0;
switchx_Cli.main();
})(typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this);
